#property copyright ". +Chart.mq4 3.1.  2009-2012 Plus."
#property link      "http://fxcoder.ru"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color2 LimeGreen
#property indicator_color3 Red
#property indicator_color4 CLR_NONE
#property indicator_color5 LimeGreen
#property indicator_color6 Red
#property indicator_color7 CLR_NONE

#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 2

//  
extern string ChartSymbol = "";

// 
extern bool Reverse = false;

//  ()
extern int ChartPeriod = 0;

//   
extern color BullColor = LimeGreen;

//   
extern color BearColor = Red;

//   (None - )
extern color BackColor = CLR_NONE;

//   (0 - )
extern int BodyWidth = 0;

//   
extern int ValuePrice = PRICE_CLOSE;

//    
extern int MaxBars = 0;

//   ( - )
extern int Shift = 0;

//      100 (      )
extern bool LogScale = false;

double Value[], BullBody[], BearBody[], BodyMask[], BullShadow[], BearShadow[], ShadowMask[];

int barWidth = 2;
color bgColor = CLR_NONE;
double point = 0;

//       
#define VShift 1000.0

//  MT4.XLib.  2011-2012 Plus (FXcoder.ru).
//   .

#import "user32.dll"
int  GetWindowDC(int h);
int  ReleaseDC(int h, int hDC);

#import "gdi32.dll"
int GetPixel(int hDC, int x, int y);
#import

//    
color GetBGColor()
{
	color bgColor = CLR_NONE;
	
	int h = WindowHandle(Symbol(), Period());
	if (h != 0)
	{
		//     .
		int hDC = GetWindowDC(h);

		//    ,   
		int c1 = GetPixel(hDC, 3, 10); // 
		int c2 = GetPixel(hDC, 4, 10); // 
		int c3 = GetPixel(hDC, 5, 10); // 

		//   ,     ( )
		if (c1 != c2 && c1 == c3)
			bgColor = c1;

		ReleaseDC(h, hDC);
	}
		
	return(bgColor);
}

//    None ( -  4)
bool ColorIsNone(color c)
{
	return((c == CLR_NONE));
}

//  MT4.XLib.  2011-2012 Plus (FXcoder.ru).
//   .

//     
string UpperString(string s)
{
	int c = StringLen(s);
	int ch;
	for (int i = 0; i < c; i++)
	{
		// Upper char
		ch = StringGetChar(s, i);
		if ((ch > 96 && ch < 123) || (ch > 223 && ch < 256))
			ch -= 32;

		s = StringSetChar(s, i, ch);
	}
	return(s);
}

//  MT4.XLib.  2011-2012 Plus (FXcoder.ru).
//  .

//      
string PeriodToStr(int period = 0)
{
	if (period == 0)
		period = Period();

	if (period < PERIOD_H1)
		return(StringConcatenate("M", period));
	else if (period < PERIOD_D1 && period % 60 == 0)
		return(StringConcatenate("H", period / 60));
	else if (period < PERIOD_W1 && period % 1440 == 0)
		return(StringConcatenate("D", period / 1440));
	else if (period == PERIOD_MN1 && period % 10080 == 0)
		return(StringConcatenate("W", period / 10080));
	else if (period == PERIOD_MN1)
		return("MN1");
	else
		return(StringConcatenate("M", period));
}

//  MT4.XLib.  2011-2012 Plus (FXcoder.ru).
//    .

#import "user32.dll"
    bool GetWindowRect(int h, int& pos[4]);
#import

//    ()
bool GetWindowBounds(int &left, int &top, int &right, int &bottom)
{
	int handle = WindowHandle(Symbol(), Period());
		
	if (handle == 0)
		return(false);
	
	int rect[4];
	if (GetWindowRect(handle, rect))
	{
		left = rect[0];
		top = rect[1];
		// ""      ,    , ..   
		right = rect[2] - 1;
		bottom = rect[3] - 1;
		
		return(true);
	}
	else
	{
		return(false);
	}
}

//    (   )  
int GetBarWidth()
{
	int left, top, right, bottom;
	int bw = 1; //    ( )
	
	if (GetWindowBounds(left, top, right, bottom))
	{
		//
		int width = right - left - 5 - 42;
		if (width != 0)
		{
			bw = MathRound(1.0 * width / WindowBarsPerChart());
			
			//  (   -  )
			bw = MathPow(2, MathRound(MathLog(bw) / MathLog(2)));
		}
	}
	
	return(bw);
}

int start()
{
	if (BodyWidth == 0)
	{
		int newBarWidth = GetBarWidth();
		if (newBarWidth != barWidth)
		{
			barWidth = newBarWidth;
			
			int w = 1;
			if (barWidth == 4)
				w = 2;
			else if (barWidth == 8)
				w = 3;
			else if (barWidth == 16)
				w = 6;
			else if (barWidth == 32)
				w = 12;
				
			SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY, w, BullColor);
			SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY, w, BearColor);
			SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, w, bgColor);
			SetIndexStyle(6, DRAW_HISTOGRAM, EMPTY, w, bgColor);
		}
	}

	color bgColor = BackColor;
	if (bgColor == CLR_NONE)
		bgColor = GetBGColor();

	if (!ColorIsNone(bgColor))
		updateMaskColor(bgColor);

	int counted_bars = IndicatorCounted();
	if (counted_bars > 0)
		counted_bars--;
	int barsCount = Bars - counted_bars;

	if (ChartPeriod != Period())
	{
		barsCount = Bars;
		clearData();
	}

	if (MaxBars > 0)
	{
		if (Bars - counted_bars > 2)
		{
			barsCount = MaxBars;
			clearData();
		}
		else
		{
			clearData(MaxBars);
			barsCount = MathMin(barsCount, MaxBars);
		}
	}
	
	double o, h, l, c, value;
	
	for (int i = barsCount - 1; i >= 0; i--)
	{
		//   
		clearData(i);

		o = EMPTY_VALUE;
		h = EMPTY_VALUE;
		l = EMPTY_VALUE;
		c = EMPTY_VALUE;
		value = EMPTY_VALUE;

		if ((ChartSymbol == Symbol()) && (ChartPeriod == Period()))
		{
			//   -   (,  ),       
			o = Open[i];
			h = High[i];
			l = Low[i];
			c = Close[i];
			reverseRates(o, h, l, c, Reverse);
			value = getPrice(ValuePrice, o, h, l, c);
		}
		else
		{
			datetime dt = iTime(Symbol(), ChartPeriod, i);
			int j = iBarShift(ChartSymbol, ChartPeriod, dt, true);
			if (j != -1)
			{
				o = iOpen(ChartSymbol, ChartPeriod, j);
				h = iHigh(ChartSymbol, ChartPeriod, j);
				l = iLow(ChartSymbol, ChartPeriod, j);
				c = iClose(ChartSymbol, ChartPeriod, j);
				reverseRates(o, h, l, c, Reverse);
				value = getPrice(ValuePrice, o, h, l, c);
			}
			else
			{
				//      ,    ,      
				if (i <= Bars - 1)
					value = Value[i + 1];
			}
		}

		//     
		if (c != EMPTY_VALUE && o > 0 && h > 0 && l > 0 && c >0)
		{
			double bullBody = EMPTY;
			double bearBody = EMPTY;
			double bodyMask = EMPTY;
			double bullShadow = EMPTY;
			double bearShadow = EMPTY;
			double shadowMask = EMPTY;

			if (Reverse)
			{
				h += l;
				l = h - l;
				h -= l;
				//     ,   -   
				point = 0;
			}

			if (o <= c)
			{
				bullBody = c;
				bodyMask = o - point;

				bullShadow = h;
			}
			else
			{
 				bearBody = o;
 				bodyMask = c - point;

   				bearShadow = h;
			}
	    
	    	shadowMask = l - point;

			// 
			if (LogScale)
			{
				if (bullBody > 0)
					BullBody[i] = MathLog(bullBody) * 100.0 + VShift;

				if (bearBody > 0)
					BearBody[i] = MathLog(bearBody) * 100.0 + VShift;

				if (bodyMask > 0)
					BodyMask[i] = MathLog(bodyMask) * 100.0 + VShift;
					
				if (bullShadow > 0)
					BullShadow[i] = MathLog(bullShadow) * 100.0 + VShift;
				
				if (bearShadow > 0)
					BearShadow[i] = MathLog(bearShadow) * 100.0 + VShift;
				
				if (shadowMask > 0)
			    	ShadowMask[i] = MathLog(shadowMask) * 100.0 + VShift;
		    	
				if (value > 0)
			    	Value[i] = MathLog(value) * 100.0 + VShift;
			}
			else
			{
				if (bullBody > 0)
					BullBody[i] = bullBody;
					
				if (bearBody > 0)
					BearBody[i] = bearBody;
					
				if (bodyMask > 0)
					BodyMask[i] = bodyMask;
					
				if (bullShadow > 0)
					BullShadow[i] = bullShadow;
				
				if (bearShadow > 0)
					BearShadow[i] = bearShadow;
		    	
		    	if (shadowMask > 0)
					ShadowMask[i] = shadowMask;
		    	
		    	if (value > 0)
					Value[i] = value;
			}

	    }
	}
	

	return(0);
}

int init()
{
	if (ChartSymbol == "")
		ChartSymbol = Symbol();
	ChartSymbol = UpperString(ChartSymbol);
	
	point = MarketInfo(ChartSymbol, MODE_POINT); 

	if (ChartPeriod == 0)
		ChartPeriod = Period();

	bgColor = GetBGColor();
	
	barWidth = BodyWidth;
	if (barWidth <= 0)
		barWidth = 1;
	
	SetIndexStyle(0, DRAW_NONE);
	SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY, barWidth, BullColor);
	SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY, barWidth, BearColor);
	SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, barWidth, bgColor);
	SetIndexStyle(4, DRAW_HISTOGRAM, EMPTY, EMPTY, BullColor);
	SetIndexStyle(5, DRAW_HISTOGRAM, EMPTY, EMPTY, BearColor);
	SetIndexStyle(6, DRAW_HISTOGRAM, EMPTY, barWidth, bgColor);

	SetIndexBuffer(0, Value);
	SetIndexBuffer(1, BullBody);
	SetIndexBuffer(2, BearBody);
	SetIndexBuffer(3, BodyMask);
	SetIndexBuffer(4, BullShadow);
	SetIndexBuffer(5, BearShadow);
	SetIndexBuffer(6, ShadowMask);

	SetIndexShift(0, -Shift);
	SetIndexShift(1, -Shift);
	SetIndexShift(2, -Shift);
	SetIndexShift(3, -Shift);
	SetIndexShift(4, -Shift);
	SetIndexShift(5, -Shift);
	SetIndexShift(6, -Shift);

	SetIndexLabel(0, "Value");

	string name = ChartSymbol;

	if (Reverse)
		name = "1/" + name;
	
	name = name + "," + PeriodToStr(ChartPeriod);

	IndicatorShortName(name);

	return(0);
}

int deinit() { return(0); }

void reverseRates(double& o, double& h, double& l, double& c, bool reverse)
{
	if (reverse)
	{
		if (o != 0 && h != 0 && l != 0 && c != 0)
		{
			o = 1 / o;
			h = 1 / h;
			l = 1 / l;
			c = 1 / c;
		}
		else
		{
			o = 0;
			h = 0;
			l = 0;
			c = 0;
		}
	}
}

void updateMaskColor(color cl)
{
	SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, EMPTY, cl);
	SetIndexStyle(6, DRAW_HISTOGRAM, EMPTY, EMPTY, cl);
}

void clearData(int bar = -1)
{
	if (bar == -1)
	{
		ArrayInitialize(Value, EMPTY_VALUE);
		ArrayInitialize(BullBody, EMPTY_VALUE);
		ArrayInitialize(BearBody, EMPTY_VALUE);
		ArrayInitialize(BodyMask, EMPTY_VALUE);
		ArrayInitialize(BullShadow, EMPTY_VALUE);
		ArrayInitialize(BearShadow, EMPTY_VALUE);
		ArrayInitialize(ShadowMask, EMPTY_VALUE);
	}
	else
	{
		Value[bar] = EMPTY_VALUE;
		BullBody[bar] = EMPTY_VALUE;
		BearBody[bar] = EMPTY_VALUE;
		BodyMask[bar] = EMPTY_VALUE;
		BullShadow[bar] = EMPTY_VALUE;
		BearShadow[bar] = EMPTY_VALUE;
		ShadowMask[bar] = EMPTY_VALUE;
	}
}

double getPrice(int ap, double o, double h, double l, double c)
{
	double price = 0;
	
	if (c != EMPTY_VALUE)
	{
		switch(ap)
		{
			case 0:
				price = c;
				break;
			
			case 1:
				price = o;
				break;
			
			case 2:
				price = h;
				break;
			
			case 3:
				price = l;
				break;
			
			case 4:
				price = (h + l) / 2.0;
				break;
			
			case 5:
				price = (h + l + c) / 3.0;
				break;
			
			case 6:
				price = (h + l + 2.0 * c) / 4.0;
				break;
		}
	}
	
	return(price);
}

// 2012-04-12 17:52:12 UTC
// MQLMake 1.9.0. Copyright  Plus 2011-2012. http://fxcoder.ru